-- author: DD ModPassion
-- date: 04.02.2020
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
PalletAddon = {} function PalletAddon.prerequisitesPresent(specializations) return true end function PalletAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "loadSchemaOverlay", PalletAddon.loadSchemaOverlay) end function PalletAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", PalletAddon) end function PalletAddon:onLoad(savegame) local spec = self.spec_mountable local palletJointNode = spec.dynamicMountTriggerId setTranslation(palletJointNode, 0,0,0) setRotation(palletJointNode, 0,0,0) createTransformGroup("BaleJointTG") spec = self.spec_attachable self.allowsInput = true self.canBeReset = true local inputAttacherJoint = {} inputAttacherJoint.node = palletJointNode local key = string.format("vehicle.attachable.inputAttacherJoints.inputAttacherJoint(%d)", 0) inputAttacherJoint.heightNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".heightNode#node"), self.i3dMappings) local jointTypeStr = "loaderFork" local jointType jointType = AttacherJoints.jointTypeNameToInt[jointTypeStr] inputAttacherJoint.jointType = jointType inputAttacherJoint.jointOrigTrans = { getTranslation(inputAttacherJoint.node) } inputAttacherJoint.topReferenceNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. "#topReferenceNode"), self.i3dMappings) inputAttacherJoint.rootNode = Utils.getNoNil(I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. "#rootNode"), self.i3dMappings), self.rootNode) inputAttacherJoint.rootNodeBackup = inputAttacherJoint.rootNode inputAttacherJoint.allowsDetaching = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#allowsDetaching"), true) inputAttacherJoint.fixedRotation = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#fixedRotation"), false) inputAttacherJoint.hardAttach = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#hardAttach"), false) inputAttacherJoint.visualNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. "#nodeVisual"), self.i3dMappings) inputAttacherJoint.lowerDistanceToGround = Utils.getNoNil(getXMLFloat(self.xmlFile, key .. ".distanceToGround#lower"), 0.7) inputAttacherJoint.upperDistanceToGround = Utils.getNoNil(getXMLFloat(self.xmlFile, key .. ".distanceToGround#upper"), 1.0) inputAttacherJoint.lowerRotationOffset = math.rad(Utils.getNoNil(getXMLFloat(self.xmlFile, key .. "#lowerRotationOffset"), 0)) local defaultUpperRotationOffset = 0 inputAttacherJoint.upperRotationOffset = math.rad(Utils.getNoNil(getXMLFloat(self.xmlFile, key .. "#upperRotationOffset"), defaultUpperRotationOffset)) inputAttacherJoint.allowsJointRotLimitMovement = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#allowsJointRotLimitMovement"), true) inputAttacherJoint.allowsJointTransLimitMovement = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#allowsJointTransLimitMovement"), true) inputAttacherJoint.needsToolbar = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#needsToolbar"), false) inputAttacherJoint.steeringBarLeftNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. "#steeringBarLeftNode"), self.i3dMappings) inputAttacherJoint.steeringBarRightNode = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. "#steeringBarRightNode"), self.i3dMappings) local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key .. "#upperRotLimitScale")) inputAttacherJoint.upperRotLimitScale = { Utils.getNoNil(x, 0), Utils.getNoNil(y, 0), Utils.getNoNil(z, 0) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key .. "#lowerRotLimitScale")) inputAttacherJoint.lowerRotLimitScale = { Utils.getNoNil(x, 1), Utils.getNoNil(y, 1), Utils.getNoNil(z, 1) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key .. "#upperTransLimitScale")) inputAttacherJoint.upperTransLimitScale = { Utils.getNoNil(x, 0), Utils.getNoNil(y, 0), Utils.getNoNil(z, 0) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key .. "#lowerTransLimitScale")) inputAttacherJoint.lowerTransLimitScale = { Utils.getNoNil(x, 0), Utils.getNoNil(y, 1), Utils.getNoNil(z, 0) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#rotLimitSpring")) inputAttacherJoint.rotLimitSpring = { Utils.getNoNil(x, 0), Utils.getNoNil(y, 0), Utils.getNoNil(z, 0) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#rotLimitDamping")) inputAttacherJoint.rotLimitDamping = { Utils.getNoNil(x, 1), Utils.getNoNil(y, 1), Utils.getNoNil(z, 1) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#rotLimitForceLimit")) inputAttacherJoint.rotLimitForceLimit = { Utils.getNoNil(x, -1), Utils.getNoNil(y, -1), Utils.getNoNil(z, -1) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#transLimitSpring")) inputAttacherJoint.transLimitSpring = { Utils.getNoNil(x, 0), Utils.getNoNil(y, 0), Utils.getNoNil(z, 0) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#transLimitDamping")) inputAttacherJoint.transLimitDamping = { Utils.getNoNil(x, 1), Utils.getNoNil(y, 1), Utils.getNoNil(z, 1) } local x, y, z = StringUtil.getVectorFromString(getXMLString(self.xmlFile,  key.."#transLimitForceLimit")) inputAttacherJoint.transLimitForceLimit = { Utils.getNoNil(x, -1), Utils.getNoNil(y, -1), Utils.getNoNil(z, -1) } inputAttacherJoint.attacherHeight = getXMLFloat(self.xmlFile, key .. "#attacherHeight") local defaultNeedsLowering = true local defaultAllowsLowering = false inputAttacherJoint.needsLowering = Utils.getNoNil(getXMLBool(self.xmlFile, key.. "#needsLowering"), defaultNeedsLowering) inputAttacherJoint.allowsLowering = Utils.getNoNil(getXMLBool(self.xmlFile, key.. "#allowsLowering"), defaultAllowsLowering) inputAttacherJoint.isDefaultLowered = Utils.getNoNil(getXMLBool(self.xmlFile, key.. "#isDefaultLowered"), false) inputAttacherJoint.useFoldingLoweredState = Utils.getNoNil(getXMLBool(self.xmlFile, key.. "#useFoldingLoweredState"), false) inputAttacherJoint.forceSelection = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#forceSelectionOnAttach"), true) inputAttacherJoint.dependentAttacherJoints = {} inputAttacherJoint.changeObjects = {} inputAttacherJoint.additionalObjects = {} table.insert(spec.inputAttacherJoints, inputAttacherJoint) end function PalletAddon:loadSchemaOverlay(xmlFile) local baseX = 0 local baseY = 0 local schemaNameDefault = "DEFAULT_IMPLEMENT" local schemaNameTurnedOn = "" local schemaNameSelected = "DEFAULT_IMPLEMENT_SELECTED" local schemaNameSelectedTurnedOn = "" local modPrefix = self.customEnvironment or "" schemaNameDefault = Vehicle.prefixSchemaOverlayName(schemaNameDefault, modPrefix) schemaNameTurnedOn = Vehicle.prefixSchemaOverlayName(schemaNameTurnedOn, modPrefix) schemaNameSelected = Vehicle.prefixSchemaOverlayName(schemaNameSelected, modPrefix) schemaNameSelectedTurnedOn = Vehicle.prefixSchemaOverlayName(schemaNameSelectedTurnedOn, modPrefix) self.schemaOverlay = VehicleSchemaOverlayData.new( baseX, baseY, schemaNameDefault, schemaNameTurnedOn, schemaNameSelected, schemaNameSelectedTurnedOn) end